using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing.Imaging;

namespace ruche.nive.aviutlPluginPorts
{
    /// <summary>
    /// ԉ摜t@C^Cv̗񋓁B
    /// </summary>
    public enum WorkImageType
    {
        /// <summary>
        /// PNG`B
        /// </summary>
        Png,

        /// <summary>
        /// BMP`B
        /// </summary>
        Bmp,

        /// <summary>
        /// 24rbgBGRgbv_E`(Ǝ`)B
        /// </summary>
        Bgr24,
    };

    /// <summary>
    /// ԉ摜t@C^Cṽ[eBeBÓINXB
    /// </summary>
    public static class WorkImageTypeUtil
    {
        /// <summary>
        /// ԉ摜t@C`ɑΉgq擾B
        /// </summary>
        /// <param name="format">ԉ摜t@C^CvB</param>
        /// <returns>gqB擪ɃsIh͕tȂB</returns>
        public static string GetExtension(WorkImageType format)
        {
            string ext = null;

            switch (format)
            {
                case WorkImageType.Png:
                    ext = "png";
                    break;

                case WorkImageType.Bmp:
                    ext = "bmp";
                    break;

                case WorkImageType.Bgr24:
                    ext = "bgr24";
                    break;

                default:
                    throw new ArgumentException(
                        "ԉ摜t@C`słB", "format");
            }

            return ext;
        }

        /// <summary>
        /// ԉ摜t@C`ɑΉC[WtH[}bg擾B
        /// </summary>
        /// <param name="format">ԉ摜t@C^CvB</param>
        /// <returns>C[WtH[}bgBƎ`̏ꍇ null B</returns>
        public static ImageFormat GetImageFormat(WorkImageType format)
        {
            ImageFormat imgFormat = null;

            switch (format)
            {
                case WorkImageType.Png:
                    imgFormat = ImageFormat.Png;
                    break;

                case WorkImageType.Bmp:
                    imgFormat = ImageFormat.Bmp;
                    break;

                case WorkImageType.Bgr24:
                    imgFormat = null;
                    break;

                default:
                    throw new ArgumentException(
                        "ԉ摜t@C`słB", "format");
            }

            return imgFormat;
        }
    };
}
